#include"Beam.h"

Beam::Beam(int inSize, int* inNodes){
	assert(inSize==2 || inSize==3);
	nodes[0]=inNodes[0];
	nodes[1]=inNodes[1];
}

int 
Beam::getNode(int position){
	assert(0<position);
	assert(position<=1);
	return nodes[position];
}

void
Beam::match(ResizeArray<Point3D*>& allPoints,
            const Point3D& matchPoint, const double tol, MatchInfo& info)const
{
	if ((allPoints[nodes[0]]==NULL)||(allPoints[nodes[1]]==NULL))
        	info.success=0;
	else {	
		Point3D p=*(allPoints[nodes[0]]);
		Point3D d=*(allPoints[nodes[1]])-p;
		info.eta=0.0;
		info.xi=dotp(matchPoint-p,d)/dotp(d,d);
		info.success=0;
		if(-tol<info.xi&&info.xi<1.0+tol){
			info.success=1;
			info.point=p+info.xi*d;
			info.dist=norm(matchPoint-info.point);
			if(info.xi>1.0)
				info.dist+=norm(info.point-*(allPoints[nodes[1]]));
			if(info.xi<0.0)
				info.dist+=norm(info.point-*(allPoints[nodes[0]]));
		}	
	}
}

void
Beam::getLocalCoordinates(int i, double &xi, double &eta)
{
  switch(i) {
    case 0:
      eta = 0.0;
      xi = 0.0;
    break;
    case 1:
      xi = 1.0;
      eta = 0.0;
    break;
  }
}
